#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <crtdbg.h>
#include <stdio.h>
#include "resource.h"
#include "common.h"

extern HWND g_hAppWnd;					//AvP[VHWND

//--------------------------------------------------------------------------------------
//	EBhȄ
HWND InitWindow( HINSTANCE hInst, LPCTSTR lpszClassName, int x, int y, int width, int height, WNDPROC lpProc, int flag )
{
	WNDCLASS		wc;
	HWND			hWnd;

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = lpProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hCursor = LoadCursor( hInst, IDC_ARROW );
	wc.hIcon = LoadIcon( hInst, MAKEINTRESOURCE( IDI_APP_ICON ) );
	wc.hbrBackground = NULL;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = lpszClassName;
	RegisterClass( &wc );

	hWnd = CreateWindowEx(
		WS_EX_TOOLWINDOW | WS_EX_LAYERED | WS_EX_TRANSPARENT | WS_EX_TOPMOST,
		lpszClassName,
		NULL,
		WS_POPUP,
		x, y,
		width, height,
		NULL,
		NULL,
		hInst,
		NULL );

	if( !hWnd )
		return NULL;
	ShowWindow( hWnd, flag );
	UpdateWindow( hWnd );
	
	return hWnd;
}

//--------------------------------------------------------------------------------------
//	rbg}bv쐬
HBITMAP CreateRGBBitmap( int x, int y, int bpp )
{
	if( bpp <= 8 )
		return NULL;

	BITMAPINFOHEADER bmiHeader;
	memset( &bmiHeader, 0, sizeof( bmiHeader ) );
	bmiHeader.biSize = sizeof( bmiHeader );
	bmiHeader.biWidth = x;
	bmiHeader.biHeight = y;
	bmiHeader.biBitCount = bpp;
	bmiHeader.biPlanes = 1;

	UCHAR *bitptr;
	HDC dc = GetDC( NULL );
	HBITMAP hbmp = CreateDIBSection( dc, (BITMAPINFO*)&bmiHeader, DIB_RGB_COLORS, (void**)&bitptr, NULL, 0 );
	ReleaseDC( NULL, dc );

	return hbmp;
}

//--------------------------------------------------------------------------------------
//	J[L[(}XN)[hUpdateLayeredWindowbv֐
void UpdateLayeredMaskImage( HWND hWnd, HBITMAP hbmp, int x, int y, int width, int height, COLORREF mask )
{
	HDC hdcScreen = GetDC( NULL );
	HDC hdcMemory = CreateCompatibleDC( hdcScreen );

	SelectObject( hdcMemory, hbmp );

	POINT pos = { x, y };
	SIZE szWindow = { width, height };
	POINT ptSrc = { 0, 0 };

	BLENDFUNCTION bf;
	bf.BlendOp = AC_SRC_OVER; //I̗]nȂiꂵȂj
	bf.BlendFlags = 0; //I̗]nȂiꂵȂj
	bf.AlphaFormat = 0; //]摜ɂ̓At@`l͖iꍇAC_SRC_ALPHAwj
	bf.SourceConstantAlpha = 0xff; //uhl

	UpdateLayeredWindow( 
		hWnd,
		hdcScreen,
		&pos,
		&szWindow,
		hdcMemory,
		&ptSrc,
		mask,
		&bf,
		ULW_COLORKEY //At@lꍇULW_ALPHA
		);

	DeleteDC( hdcMemory );
	ReleaseDC( NULL, hdcScreen );
}